package com.onlinebank.transaction.to;

import java.io.Serializable;
import java.util.Date;

/**
 * This class represents a transaction.
 * 
 * @author Leon Rubin
 */
public class Transaction implements Serializable {
	private static final long serialVersionUID = 1L;

	private String number;
	private String description;
	private double amount;
	private Date date;

	/**
	 * Creates a transaction.
	 */
	public Transaction() { 

	}

	/**
	 * Gets the transaction ammount.
	 * 
	 * @return double containing the transaction ammount
	 */
	public double getAmount() {
		return amount;
	}

	/**
	 * Sets the transaction ammount.
	 * 
	 * @param ammount
	 *            transaction ammount
	 */
	public void setAmount(double amount) {
		this.amount = amount;
	}

	/**
	 * Gets the transaction description.
	 * 
	 * @return String containing the transaction description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Sets the transaction description.
	 * 
	 * @param description
	 *            transaction description
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Gets the transaction number.
	 * 
	 * @return String containing the transaction number
	 */
	public String getNumber() {
		return number;
	}

	/**
	 * Sets the transaction number.
	 * 
	 * @param number
	 *            transaction number
	 */
	public void setNumber(String number) {
		this.number = number;
	}

	/**
	 * Gets the transaction date.
	 * 
	 * @return Date containing the transaction date
	 */
	public Date getDate() {
		return date;
	}

	/**
	 * Sets the transaction date.
	 * 
	 * @param date
	 *            transaction date
	 */
	public void setDate(Date date) {
		this.date = date;
	}
}
