package com.democompany.soa.esb.adaptor.util.http;

import javax.servlet.FilterConfig;
import javax.servlet.ServletContext;

/**
 * This class is a simple implementation of the FilterConfig interface. The
 * entry point into the Struts2 framework is an HTTP filter that is typically
 * configured in a web.xml, however in this application, there is no web.xml and
 * no web server to create a filter and pass configuration to it. Both the
 * Struts2 filter and the configuration are created programatically in the init
 * method of the Custom Java Service. The requirements for the configuration
 * object are minimal - it simply has to exist. Javadoc comments are not
 * provided because all methods will inherit them from the
 * javax.servlet.FilterConfig interface.
 * 
 * @author Leon Rubin
 */
public class FilterConfigImpl extends InitializableObject implements
		FilterConfig {
	private String filterName;
	private ServletContext servletContext;

	/**
	 * Creates a filter config for a filter with a specified name.
	 * 
	 * @param filterName
	 *            filter name
	 */
	public FilterConfigImpl(String filterName) {
		this.filterName = filterName;
	}

	public ServletContext getServletContext() {
		return servletContext;
	}

	public void setServletContext(ServletContext servletContext) {
		this.servletContext = servletContext;
	}

	public String getFilterName() {
		return filterName;
	}
}
