package com.democompany.soa.esb.adaptor.util.http;

import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import javax.servlet.http.Cookie;

import com.democompany.soa.esb.adaptor.util.exception.NotImplementedException;

/**
 * This abstract class defines all the functionality that is common between the
 * HttpServletRequest and the HttpServletResponse implementations and allows to
 * reuse (inherit) that functionality. Javadoc comments are not provided because
 * all methods will inherit them from the HttpServletRequest and
 * HttpServletRequest interfaces.
 * 
 * @author Leon Rubin
 */
public abstract class HttpServletMessage extends AttributeCollection {
	private String contentType;
	private int contentLength;
	private String characterEncoding;
	private Map<String, String> parameterMap;

	/**
	 * Creates the http servlet message.
	 */
	public HttpServletMessage() {
		parameterMap = new HashMap<String, String>();
	}

	public long getDateHeader(String arg0) {
		throw new NotImplementedException();
	}

	public String getHeader(String arg0) {
		throw new NotImplementedException();
	}

	public Enumeration getHeaderNames() {
		throw new NotImplementedException();
	}

	public Enumeration getHeaders(String arg0) {
		throw new NotImplementedException();
	}

	public int getIntHeader(String arg0) {
		throw new NotImplementedException();
	}

	public void addDateHeader(String arg0, long arg1) {
		throw new NotImplementedException();
	}

	public void addHeader(String arg0, String arg1) {
		throw new NotImplementedException();
	}

	public void addIntHeader(String arg0, int arg1) {
		throw new NotImplementedException();
	}

	public boolean containsHeader(String arg0) {
		throw new NotImplementedException();
	}

	public void setDateHeader(String arg0, long arg1) {
		throw new NotImplementedException();
	}

	public void setHeader(String arg0, String arg1) {
		throw new NotImplementedException();
	}

	public void setIntHeader(String arg0, int arg1) {
		throw new NotImplementedException();
	}

	public void addCookie(Cookie arg0) {
		throw new NotImplementedException();
	}

	public Cookie[] getCookies() {
		throw new NotImplementedException();
	}

	public String getCharacterEncoding() {
		return characterEncoding;
	}

	public int getContentLength() {
		return contentLength;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	public String getContentType() {
		return contentType;
	}

	public void setContentLength(int contentLength) {
		this.contentLength = contentLength;
	}

	public Locale getLocale() {
		// This method does not need to return a valid reference but it is used
		// by the framework and therefore should not throw
		// NotImplementedException
		return null;
	}

	public Enumeration getLocales() {
		throw new NotImplementedException();
	}

	public void setLocale(Locale locale) {
		throw new NotImplementedException();
	}

	public String getParameter(String name) {
		return parameterMap.get(name);
	}

	public Map getParameterMap() {
		return parameterMap;
	}

	public void setParameterMap(Map<String, String> parameterMap) {
		this.parameterMap = parameterMap;
	}

	public Enumeration getParameterNames() {
		throw new NotImplementedException();
	}

	public String[] getParameterValues(String arg0) {
		throw new NotImplementedException();
	}

	public void setCharacterEncoding(String characterEncoding)
			throws UnsupportedEncodingException {
		this.characterEncoding = characterEncoding;
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer();

		buffer.append(getClass().getName());
		buffer.append("\n{\n");
		buffer.append("\tAttributes:");

		Enumeration e = getAttributeNames();

		while (e.hasMoreElements()) {
			String attributeName = (String) e.nextElement();
			buffer.append("\t\t");
			buffer.append(attributeName);
			buffer.append(" = ");
			buffer.append(getAttribute(attributeName));
			buffer.append("\n");
		}

		buffer.append("}\n");

		return buffer.toString();
	}
}
