package com.democompany.soa.esb.adaptor.util.http;

import java.io.BufferedReader;
import java.io.IOException;
import java.security.Principal;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.democompany.soa.esb.adaptor.util.exception.NotImplementedException;

/**
 * This class implements the HttpServletRequest interface. It is a very basic
 * implementation that contains only the most essential functionality necessary
 * to represent an XQMessage as an HttpServletRequest. Methods that are not
 * necessary throw a runtime NotImplementedException. If such exception occurs,
 * that means that either Struts or the application does use one of those
 * methods and pinpoints which method implementation must be provided. Javadoc
 * comments are not provided because all methods will inherit them from the
 * HttpServletRequest.
 * 
 * @author Leon Rubin
 */
public class HttpServletRequestImpl extends HttpServletMessage implements
		HttpServletRequest {
	private String protocol;
	private String serverName;
	private int serverPort;
	private String method;
	private String contextPath;
	private String servletPath;
	private StringBuffer requestUrl;
	private RequestDispatcher requestDispatcher;

	/**
	 * Creates an http servlet request implementation.
	 */
	public HttpServletRequestImpl() {
		requestDispatcher = new RequestDispatcherImpl();
	}

	public String getAuthType() {
		throw new NotImplementedException();
	}

	public String getMethod() {
		return method;
	}

	public String getContextPath() {
		return contextPath;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getPathInfo() {
		throw new NotImplementedException();
	}

	public String getPathTranslated() {
		throw new NotImplementedException();
	}

	public String getQueryString() {
		throw new NotImplementedException();
	}

	public String getRemoteUser() {
		throw new NotImplementedException();
	}

	public String getRequestURI() {
		// This method does not need to return a valid reference but it is used
		// by the framework and therefore should not throw
		// NotImplementedException
		return null;
	}

	public String getRequestedSessionId() {
		throw new NotImplementedException();
	}

	public String getServletPath() {
		return servletPath;
	}

	public HttpSession getSession() {
		throw new NotImplementedException();
	}

	public HttpSession getSession(boolean createNewIfDoesNotExist) {
		// This method does not need to return a valid reference but it is used
		// by the framework and therefore should not throw
		// NotImplementedException
		return null;
	}

	public Principal getUserPrincipal() {
		throw new NotImplementedException();
	}

	public boolean isRequestedSessionIdFromCookie() {
		throw new NotImplementedException();
	}

	public boolean isRequestedSessionIdFromURL() {
		throw new NotImplementedException();
	}

	public boolean isRequestedSessionIdFromUrl() {
		throw new NotImplementedException();
	}

	public boolean isRequestedSessionIdValid() {
		throw new NotImplementedException();
	}

	public boolean isUserInRole(String arg0) {
		throw new NotImplementedException();
	}

	public ServletInputStream getInputStream() throws IOException {
		throw new NotImplementedException();
	}

	public String getProtocol() {
		return protocol;
	}

	public BufferedReader getReader() throws IOException {
		throw new NotImplementedException();
	}

	public String getRealPath(String arg0) {
		throw new NotImplementedException();
	}

	public String getRemoteAddr() {
		throw new NotImplementedException();
	}

	public String getRemoteHost() {
		throw new NotImplementedException();
	}

	public RequestDispatcher getRequestDispatcher(String path) {
		return requestDispatcher;
	}

	public void setRequestDispatcher(RequestDispatcher requestDispatcher) {
		this.requestDispatcher = requestDispatcher;
	}

	public String getScheme() {
		throw new NotImplementedException();
	}

	public String getServerName() {
		return serverName;
	}

	public int getServerPort() {
		return serverPort;
	}

	public boolean isSecure() {
		throw new NotImplementedException();
	}

	public void setServletPath(String servletPath) {
		this.servletPath = servletPath;
	}

	public StringBuffer getRequestURL() {
		return requestUrl;
	}

	public void setRequestURL(String requestUrl) {
		this.requestUrl = new StringBuffer(requestUrl);
	}
}
