package com.democompany.soa.esb.adaptor.util.http;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

import com.democompany.soa.esb.adaptor.util.exception.NotImplementedException;

/**
 * This class implements the HttpServletResponse interface. It is a very basic
 * implementation that contains only the essential functionality necessary to
 * represent an XQMessage as an HttpServletResponse. Methods that are not
 * necessary throw a runtime NotImplementedException. If such exception occurs,
 * that means that either Struts or an application uses one of those methods and
 * pinpoints the method for which an implementation must be provided. Javadoc
 * comments are not provided because all methods will inherit them from the
 * HttpServletResponse.
 * 
 * @author Leon Rubin
 */
public class HttpServletResponseImpl extends HttpServletMessage implements
		HttpServletResponse {
	private StringWriter outputStringWriter;
	private PrintWriter writer;

	/**
	 * Creates an http servlet response implementation.
	 */
	public HttpServletResponseImpl() {
		outputStringWriter = new StringWriter();
		writer = new PrintWriter(outputStringWriter);
	}

	public String encodeRedirectURL(String arg0) {
		throw new NotImplementedException();
	}

	public String encodeRedirectUrl(String arg0) {
		throw new NotImplementedException();
	}

	public String encodeURL(String arg0) {
		throw new NotImplementedException();
	}

	public String encodeUrl(String arg0) {
		throw new NotImplementedException();
	}

	public void sendError(int code) throws IOException {
		System.out.println("sendError " + code);
	}

	public void sendError(int code, String message) throws IOException {
		System.out.println("sendError " + code + ", " + message);
	}

	public void sendRedirect(String arg0) throws IOException {
		System.out.println("sendRedirect " + arg0);
	}

	public void setStatus(int arg0) {
		throw new NotImplementedException();
	}

	public void setStatus(int arg0, String arg1) {
		throw new NotImplementedException();
	}

	public void flushBuffer() throws IOException {
		throw new NotImplementedException();
	}

	public int getBufferSize() {
		throw new NotImplementedException();
	}

	public ServletOutputStream getOutputStream() throws IOException {
		throw new NotImplementedException();
	}

	public PrintWriter getWriter() throws IOException {
		return writer;
	}

	public boolean isCommitted() {
		return false;
	}

	public void reset() {
		throw new NotImplementedException();
	}

	public void resetBuffer() {
		throw new NotImplementedException();
	}

	public void setBufferSize(int arg0) {
		throw new NotImplementedException();
	}

	public String getOutput() {
		return outputStringWriter.getBuffer().toString();
	}
}
