package com.democompany.soa.esb.adaptor.util.http;

import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Set;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;

import com.democompany.soa.esb.adaptor.util.exception.NotImplementedException;

/**
 * This class is a simple implementation of the ServletContext interface.
 * Typically, the servlet context is create by the web server and passed to web
 * components by the container, however in this case, there is no web server so
 * the servlet context object is created programatically and passed into methods
 * that require it. The functionality that the context must implement is
 * minimal, it simply has to be present. The most important use of the servlet
 * context is to locate resources and load them from the class path (Struts and
 * Spring both rely on that functionality). That means that the
 * getResourceAsStream method must be implemented properly. Javadoc comments are
 * not provided because all methods will inherit them from the ServletContext.
 * 
 * @author Leon Rubin
 */
public class ServletContextImpl extends AttributeCollection implements
		ServletContext {
	/**
	 * Creates a servlet context implementation.
	 */
	public ServletContextImpl() {

	}

	public ServletContext getContext(String arg0) {
		return null;
	}

	public int getMajorVersion() {
		throw new NotImplementedException();
	}

	public String getMimeType(String arg0) {
		throw new NotImplementedException();
	}

	public int getMinorVersion() {
		throw new NotImplementedException();
	}

	public RequestDispatcher getNamedDispatcher(String name) {
		throw new NotImplementedException();
	}

	public String getRealPath(String arg0) {
		throw new NotImplementedException();
	}

	public RequestDispatcher getRequestDispatcher(String path) {
		throw new NotImplementedException();
	}

	public URL getResource(String name) throws MalformedURLException {
		throw new NotImplementedException();
	}

	/**
	 * Loads a resource with a specified name from the classpath and returns an
	 * InputStream to it (in this application, all resources that are in the
	 * classpath of the ESB container can be loaded and returned).
	 * 
	 * @param resource
	 *            name of the resource
	 * @return InputStream to that resource
	 */
	public InputStream getResourceAsStream(String resource) {
		if (resource != null && resource.startsWith("/")) {
			resource = resource.substring(1);
		}

		InputStream is = getClass().getClassLoader().getResourceAsStream(
				resource);

		return is;
	}

	public Set getResourcePaths(String arg0) {
		throw new NotImplementedException();
	}

	public String getServerInfo() {
		return null;
	}

	public Servlet getServlet(String arg0) throws ServletException {
		throw new NotImplementedException();
	}

	public String getServletContextName() {
		throw new NotImplementedException();
	}

	public Enumeration getServletNames() {
		throw new NotImplementedException();
	}

	public Enumeration getServlets() {
		throw new NotImplementedException();
	}

	public void log(String message) {
		System.out.println("log " + message);
	}

	public void log(Exception e, String message) {
		System.out.println("log " + e + " " + message);
	}

	public void log(String message, Throwable t) {
		System.out.println("log " + message + " " + t);
	}
}
