package com.onlinebank.transaction.dao.test;

import java.util.Calendar;

import com.onlinebank.transaction.dao.TransactionDAO;
import com.onlinebank.transaction.to.Transaction;
import com.onlinebank.transaction.to.TransactionCriteria;
import com.onlinebank.transaction.to.TransactionSearchResult;
import com.onlinebank.util.exception.DAOException;

/**
 * Test implementation of the TransactionDAO that makes it possible to run the
 * application without the database being available (all objects are hardcoded
 * moch objects).
 * 
 * @author Leon Rubin
 */
public class TransactionDAOTestImpl implements TransactionDAO {
	/**
	 * Test implementation of the findTransactions method that returns three
	 * hardcoded transactions for any search criteria. For some negative
	 * testing, the method with throw a DAO exception for any account that
	 * starts with 999.
	 */
	public TransactionSearchResult findTransactions(
			TransactionCriteria transactionCriteria) throws DAOException {

		if (transactionCriteria.getAccountNumber().startsWith("999")) {
			throw new DAOException("System Down");
		}

		TransactionSearchResult result = new TransactionSearchResult();

		Transaction t1 = new Transaction();

		t1.setNumber("1097");
		t1.setDate(Calendar.getInstance().getTime());
		t1.setAmount(45.77);
		t1.setDescription("INTEREST FROM 10/22/2007 THROUGH 11/22/2007");

		result.addTransaction(t1);

		Transaction t2 = new Transaction();

		t2.setNumber("1098");
		t2.setDate(Calendar.getInstance().getTime());
		t2.setAmount(1225.79);
		t2.setDescription("AUTOMATED DEBIT ONLINE BROKER ACH IN");

		result.addTransaction(t2);

		Transaction t3 = new Transaction();

		t3.setNumber("1099");
		t3.setDate(Calendar.getInstance().getTime());
		t3.setAmount(321.25);
		t3.setDescription("AUTOMATED DEBIT CREDIT CARD E-PAYMENT");

		result.addTransaction(t3);

		return result;
	}
}
